var gFavLocBundle;

var FavLocContext = {
	//Checks to see if the FavLoc menu should be displayed
	checkContext: function() {
		if(gContextMenu != null) {
			gContextMenu.showItem("context-favloc", (gContextMenu.onLink || gContextMenu.onImage));  	
		}
	},

	//Populate context submenu from saved preferences
	init: function() {
		gFavLocBundle = document.getElementById("bundle_favloc");
		var popup = document.getElementById("context-favloc-popup");			
		
		while(popup.hasChildNodes()) {
				popup.removeChild(popup.firstChild);
		}
			
		var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		
		var prefs = prefservice.getBranch("");
		var favorites = new Array();
		var names = new Array();
		
		if (prefs.getPrefType("extensions.favloc.favorites") == prefs.PREF_STRING) {
			var favoriteList = prefs.getCharPref("extensions.favloc.favorites");
			favorites = favoriteList.split("|");
		}
		if (prefs.getPrefType("extensions.favloc.names") == prefs.PREF_STRING) {
			var nameList = prefs.getCharPref("extensions.favloc.names");
			names = nameList.split("|");
		}
		
		if(favorites.length > 0 && (names[0] != "" && favorites[0] != "")) {
			for(var i = 0; i < favorites.length; i++) {
				if(favorites[i] != "" && names[i] != "") {
					var menuitem = document.createElement('menuitem');
					menuitem.setAttribute('label', names[i]);
					menuitem.setAttribute('value', favorites[i]);
					menuitem.addEventListener("command", function(e) { new FavLocContext.download(this.value); }, false);
					popup.appendChild(menuitem);
				}
			}
		}
		else {
			var menuitem = document.createElement('menuitem');
			menuitem.setAttribute('label', "(" + gFavLocBundle.getString("favloc.noneset") + ")");
			menuitem.setAttribute('disabled', true);
			popup.appendChild(menuitem);
		}
					
		prefs = null;
		
		document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", function(e) { new FavLocContext.checkContext(); }, false);
	},
	
	//Download file
	download: function(location) {
		var url;
		if(gContextMenu.imageURL != "") {
			url = gContextMenu.imageURL;
		}
		else {
			url = gContextMenu.linkURL;
		}
		var mediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var browser = mediator.getMostRecentWindow("navigator:browser");
		
		var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		dir.initWithPath(location);
		
		if(dir.exists()) {
			var filename = browser.getDefaultFileName(null, browser.makeURI(url), null, null);
			dir.append(filename);
			
			
			var chosenData = new browser.AutoChosen(dir, browser.makeURI(url));
			
			if(gContextMenu.onLink) {
				browser.internalSave(url, null, "", null, null, null, null, chosenData, null, true);
			}
			else if(gContextMenu.onImage) {
			 	browser.saveImageURL(url, null, null, null, true, null, chosenData);
			}
		} else {
			alert(gFavLocBundle.getString("favloc.nolongerexists"));
		}
	}
	
};

window.addEventListener("load",  function(e) { new FavLocContext.init(); }, false);