var gFavLocBundle;

var FavLocFile = {
	//Populate file submenu from saved preferences
	init: function() {
		gFavLocBundle = document.getElementById("bundle_favloc");
		var popup = document.getElementById("file-favloc-popup");			
		
		while(popup.hasChildNodes()) {
				popup.removeChild(popup.firstChild);
		}
			
		var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		
		var prefs = prefservice.getBranch("");
		var favorites = new Array();
		var names = new Array();
		
		if (prefs.getPrefType("extensions.favloc.favorites") == prefs.PREF_STRING) {
			var favoriteList = prefs.getCharPref("extensions.favloc.favorites");
			favorites = favoriteList.split("|");
		}
		if (prefs.getPrefType("extensions.favloc.names") == prefs.PREF_STRING) {
			var nameList = prefs.getCharPref("extensions.favloc.names");
			names = nameList.split("|");
		}
		
		if(favorites.length > 0 && (names[0] != "" && favorites[0] != "")) {
			for(var i = 0; i < favorites.length; i++) {
				if(favorites[i] != "" && names[i] != "") {
					var menuitem = document.createElement('menuitem');
					menuitem.setAttribute('label', names[i]);
					menuitem.setAttribute('value', favorites[i]);
					menuitem.addEventListener("command", function(e) { new FavLocFile.download(this.value); }, false);
					popup.appendChild(menuitem);
				}
			}
		}
		else {
			var menuitem = document.createElement('menuitem');
			menuitem.setAttribute('label', "(" + gFavLocBundle.getString("favloc.noneset") + ")");
			menuitem.setAttribute('disabled', true);
			popup.appendChild(menuitem);
		}
		
		var menuitem = document.createElement('menuseparator');
		popup.appendChild(menuitem);
			
		var menuitem = document.createElement('menuitem');
		menuitem.setAttribute('id', "file-favloc-options");
		menuitem.setAttribute('label', gFavLocBundle.getString("favloc.popupmenuoptions"));
		menuitem.setAttribute('accesskey', gFavLocBundle.getString("favloc.popupmenuoptions-accesskey"));
		menuitem.addEventListener("command", function(e) { new FavLocOptions.showOptions(); }, false);
		popup.appendChild(menuitem);
					
		prefs = null;
	},
	
	//Download file
	download: function(location) {
		var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = prefservice.getBranch("");
		
		if (prefs.getPrefType("extensions.favloc.savetype") == prefs.PREF_STRING) {
			var saveType = prefs.getCharPref("extensions.favloc.savetype");
		}
		else {
			var saveType = 'filename';
		}
					
		prefs = null;
		
		var aDocument = document.commandDispatcher.focusedWindow.document;
		var url = aDocument.location.href;
		var mediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var browser = mediator.getMostRecentWindow("navigator:browser");
		
		var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		dir.initWithPath(location);
		
		//from saveDocument() contentAreaUtils.js
		var contentDisposition = null;
		  try {
			contentDisposition =
			  aDocument.defaultView
					   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
					   .getInterface(Components.interfaces.nsIDOMWindowUtils)
					   .getDocumentMetadata("content-disposition");
		  } catch (ex) {
			// Failure to get a content-disposition is ok
		  }
		
		if(dir.exists()) {
			var filename = browser.getDefaultFileName(null, browser.makeURI(url), aDocument, contentDisposition);

			if(filename.indexOf('.') == -1) {
				filename += '.' + browser.getDefaultExtension(aDocument.title, browser.makeURI(url), aDocument.contentType);
			}
			
			filename = browser.validateFileName(filename);
			dir.append(filename);
			
			var chosenData = new browser.AutoChosen(dir, browser.makeURI(url));		
			
			browser.internalSave(url, aDocument, filename, contentDisposition, aDocument.contentType, false, null, chosenData, null, true);
		} else {
			alert(gFavLocBundle.getString("favloc.nolongerexists"));
		}
	}
	
};

window.addEventListener("load",  function(e) { new FavLocFile.init(); }, false);