var gFavLocBundle;

var FavLocOptions = {
	
	//Show options window
	showOptions: function() {
		var optionsWindow = window.openDialog("chrome://favloc/content/favlocOptions.xul", "","chrome,resizable,centerscreen,close=no,modal");
		optionsWindow.focus();
	},

	//Open filepicker to select folder
	openFilePicker: function() {
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fp.init(window, "Select a folder", nsIFilePicker.modeGetFolder);
		var res = fp.show();
		if (res == nsIFilePicker.returnOK){
			document.getElementById("location").value=fp.file.path;
		}
		this.enableAddButton();
	},
	
	//Enable/disable add button based on input
	enableAddButton: function() {
		var name = document.getElementById("name").value;
		var location = document.getElementById("location").value;
		var addloc = document.getElementById("addloc");
		
		if(name != "" && location != "") {
			addloc.disabled=false;
		}
		else {
			addloc.disabled=true;
		}
	},
	
	//Enable delete, move up, move down buttons when an item is selected
	enableControlButtons: function() {
		var listbox = document.getElementById('favorites');
		var selected = listbox.selectedItem;
		if(selected) {
			var index = listbox.getIndexOfItem(selected);
			var lastIndex = listbox.getRowCount() - 1;
	
			if(index != 0)
				document.getElementById("uploc").disabled = false;
			else
				document.getElementById("uploc").disabled = true;
				
			if(index != lastIndex)
				document.getElementById("downloc").disabled = false;
			else
				document.getElementById("downloc").disabled = true;
				
			document.getElementById("delloc").disabled = false;
		}	
	},
	
	//Disable delete, move up, move down buttons when an item is deleted
	disableControlButtons: function() {
		document.getElementById("uploc").disabled = true;
		document.getElementById("downloc").disabled = true;
		document.getElementById("delloc").disabled = true;	
	},
	
	//Add new favorite location to the listbox
	addNewLoc: function() {
		var name = document.getElementById('name');
		var location = document.getElementById('location');
		
        var listbox = document.getElementById('favorites');

		var row = document.createElement('listitem');
		var cell = document.createElement('listcell');
		cell.setAttribute('label', name.value);
		row.appendChild(cell);
		var cell2 = document.createElement('listcell');
		cell2.setAttribute('label', location.value);
		row.appendChild(cell2);
		listbox.appendChild(row);

        name.value = "";
		location.value = ""
        this.enableAddButton();
	},
	
	//Delete location from the listbox
	deleteLoc: function() {
		var listbox = document.getElementById('favorites');
		var selected = listbox.selectedItem;

		listbox.removeItemAt(listbox.getIndexOfItem(selected));
		
		this.disableControlButtons();
	},
	
	//Move location up in listbox
	moveLocUp: function() {
		var listbox = document.getElementById('favorites');
		var selected = listbox.selectedItem;
		var previous = listbox.getPreviousItem(selected, 1);
		
		listbox.insertBefore(selected, previous);
		listbox.selectItem(selected);
	},
	
	//Move location down in listbox
	moveLocDown: function() {
		var listbox = document.getElementById('favorites');
		var selected = listbox.selectedItem;
		var next = listbox.getNextItem(selected, 2);
		
		listbox.insertBefore(selected, next);
		listbox.selectItem(selected);
	},
	
	//Populate the listbox from preferences
	init: function() {
		gFavLocBundle = document.getElementById("bundle_favloc");
        
		var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
        
        var prefs = prefservice.getBranch("");
        var favorites = new Array();
		var names = new Array();
        
        if(prefs.getPrefType("extensions.favloc.favorites") == prefs.PREF_STRING) {
            var favoriteList = prefs.getCharPref("extensions.favloc.favorites");
            favorites = favoriteList.split("|");
		}
        if(prefs.getPrefType("extensions.favloc.names") == prefs.PREF_STRING) {
            var nameList = prefs.getCharPref("extensions.favloc.names");
            names = nameList.split("|");
		}

        var listbox = document.getElementById('favorites');
		
		for(var i = 0; i < favorites.length; i++) {
			if(favorites[i] != "" && names[i] != "") {
				var row = document.createElement('listitem');
				var cell = document.createElement('listcell');
				cell.setAttribute('label', names[i]);
				row.appendChild(cell);
				var cell2 = document.createElement('listcell');
				cell2.setAttribute('label', favorites[i]);
				row.appendChild(cell2);
				listbox.appendChild(row);
			}
		}
		
		prefs = null;
		
		document.getElementById('name').addEventListener("input", function(e) { new FavLocOptions.enableAddButton(); }, false);
   },
   
   //Save the listbox to preferences file
	setOptions: function() {
		var mediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var browser = mediator.getMostRecentWindow("navigator:browser");
		
		if(document.getElementById("name").value != '' || document.getElementById("location").value != '') {
			if(!confirm(gFavLocBundle.getString("favloc.notadded"))) {
				return false;
			}
		}
		
		var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = prefService.getBranch("");
		
		var favorites = "";
		var names = "";
        var listbox = document.getElementById('favorites');
		var listcell = document.getElementsByTagName("listcell");
        var rows = listbox.getRowCount();
		
        for(var i = 0; i < (rows*2); i=i+2) {
			if(favorites != "") {
				favorites += "|";
			}
			if(names != "") {
				names += "|";
			}
			names += listcell[i].getAttribute("label");
			favorites += listcell[i+1].getAttribute("label");
        }
		
		prefs.setCharPref("extensions.favloc.favorites", favorites);
		prefs.setCharPref("extensions.favloc.names", names);
		
		browser.FavLocContext.init();
		browser.FavLocFile.init();		
		window.close();
		
		return true;
   }
   	
};