var gFavLocBundle;

var FavLocUnknown = {

	//If user selects from the drop down box, change mode/radio button to favloc
	selectFavLoc: function() {
		document.getElementById("mode").selectedItem = document.getElementById("favlocRadio");
	},
	
	//Download file
	dialogAccept: function() {
		var mediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var browser = mediator.getMostRecentWindow("navigator:browser");
		
		if(document.getElementById("mode").selectedItem == document.getElementById("favlocRadio")) {
			var url = dialog.mLauncher.source.spec;
			var filename = dialog.mLauncher.suggestedFileName;
			var location = document.getElementById("favlocList").value;
			
			var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			dir.initWithPath(location);
			
			if(dir.exists()) {
				dir.append(filename);
				window.close();
				var chosenData = new browser.AutoChosen(dir, browser.makeURI(url));
				browser.internalSave(url, null, "", null, null, null, null, chosenData, null, true);
			} else {
				alert(gFavLocBundle.getString("favloc.nolongerexists"));
			}
		}
		else {
			dialog.onOK();
		}
	},
	
	//enable/disable remember choice checkbox based on which mode is selected
	updateSelected: function() {
		radiogroup = document.getElementById("mode");
		
		if(radiogroup.selectedItem == document.getElementById("favlocRadio")) {
			document.getElementById("rememberChoice").disabled = true;
		}
		else {
			document.getElementById("rememberChoice").disabled = false;
		}
	},

	//Populate dropdown menu from saved preferences
	init: function() {
		gFavLocBundle = document.getElementById("bundle_favloc");
		
		var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		
		var prefs = prefservice.getBranch("");
		var favorites = new Array();
		var names = new Array();
		
		if (prefs.getPrefType("extensions.favloc.favorites") == prefs.PREF_STRING) {
			var favoriteList = prefs.getCharPref("extensions.favloc.favorites");
			favorites = favoriteList.split("|");
		}
		if (prefs.getPrefType("extensions.favloc.names") == prefs.PREF_STRING) {
			var nameList = prefs.getCharPref("extensions.favloc.names");
			names = nameList.split("|");
		}
	
		var popup = document.getElementById("favlocPopup");
		
		if(favorites.length > 0 && (names[0] != "" && favorites[0] != "")) {
			for(var i = 0; i < favorites.length; i++) {
				if(favorites[i] != "" && names[i] != "") {
					var menuitem = document.createElement('menuitem');
					menuitem.setAttribute('label', names[i]);
					menuitem.setAttribute('value', favorites[i]);
					popup.appendChild(menuitem);
				}
			}
		}
		else {
			document.getElementById("favlocList").disabled = true;
			document.getElementById("favlocRadio").disabled = true;
		}
		prefs = null;
		
		var radiogroup = document.getElementById("mode");
		radiogroup.addEventListener("select", function(e) { new FavLocUnknown.updateSelected(); }, false);
		document.documentElement.setAttribute('ondialogaccept', 'FavLocUnknown.dialogAccept()');
	}

};

window.addEventListener("load",  function(e) { new FavLocUnknown.init(); }, false);